>{-# OPTIONS -fglasgow-exts #-}

> module ArrowExcept where

> import Arrow

Exceptions

> class Arrow a => ArrowExcept ex a where
>	raise :: a ex b

Encapsulation.  These two could probably be combined, since the resulting
arrow is always the arrow of the handler.  Separating them has the
advantage of consistency with the other arrows, and might give more
helpful type error messages.

> class (ArrowExcept ex a, Arrow a') => ArrowRunExcept ex a a' | a -> a' where
>	runExcept :: a b c -> a' (b,ex) c -> a' b c

> class ArrowExcept ex a => ArrowNewExcept ex a where
>	newExcept :: a b c -> a (b,ex) c -> a b c

Maybe is a special case.

> class (Arrow a, Arrow a') => ArrowRunMaybe a a' | a -> a' where
>	runMaybe :: a b c -> a' b c -> a' b c
